﻿@using System;
@using System.Web;
@using System.Web.Helpers;
@using System.Collections.Generic;
@using WebMatrix.Data;

@* Remove this section if you are using bundling *@
@section Scripts {
    <script src="~/Scripts/jquery.validate.min.js"></script>
    <script src="~/Scripts/jquery.validate.unobtrusive.min.js"></script>
}

@{
    Layout = "~/_SiteLayout.cshtml";
    Page.Title = "Register";

    // Initialize general page variables
    var name = "";
    var email = "";
    var password = "";
    var confirmPassword = "";
    var salt = "";

    // Setup validation
    PWValidation validation = new PWValidation();
    Validation.RequireField("name", "Everybody has a name. What's yours?");
    Validation.RequireField("email", "You must specify an email address.");
    Validation.RequireField("password", "Password cannot be blank.");
    Validation.RequireField("salt", "You must enter something, whatever you want, anything! Just enter something!");
    Validation.Add("confirmPassword",
        Validator.EqualsTo("password", "Password and confirmation password do not match."));
    
    // If this is a POST request, validate and process data
    if (IsPost) {
        AntiForgery.Validate();
        name = Request.Form["name"];
        email = Request.Form["email"];
        password = Request.Form["password"];
        confirmPassword = Request.Form["confirmPassword"];
        salt = Request.Form["salt"];

        if(!validation.isValidPassword(password) || !Validation.IsValid()) {
            if(!validation.longEnough(password)) {
                ModelState.AddError("password", "Niet lang genoeg!");
            }
            if(!validation.hasUppercase(password)) {
                ModelState.AddError("password", "Geen hoofdletters!");
            }
            if(!validation.hasLowercase(password)) {
                ModelState.AddError("password", "Geen kleine letters!");
            }
            if(!validation.hasDigit(password)) {
                ModelState.AddError("password", "Geen cijfers!");
            }
            if(!validation.hasSpecialCharacter(password)) {
                ModelState.AddError("password", "Geen speciale karakters!");
            }
        } else {
            // Insert a new user into the database
            var db = Database.Open("webdev");

            // Check if user already exists
            var user = db.QuerySingle("SELECT Email FROM Accounts WHERE LOWER(Email) = LOWER(@0)", email);
            if (user == null) {

                // Insert email into the profile table
                var enc_pass = Crypto.SHA256(password + salt);
                db.Execute("INSERT INTO Accounts (Email, Password, Salt, Name, passplain) VALUES (@0, @1, @2, @3, @4)", email.ToLower(), enc_pass, salt, name, password);

                // Navigate back to the homepage and exit
                //WebSecurity.Login(email, password);
                Session["username"] = email;
                Response.Redirect("~/Profile");
            } else {
                // User already exists
                ModelState.AddFormError("Email address is already in use.");
            }
        }
    }
}

<hgroup class="title">
    <h1>@Page.Title.</h1>
    <h2>Create a new account.</h2>
</hgroup>

<form method="post">
    @AntiForgery.GetHtml()
    @* If at least one validation error exists, notify the user *@
    @Html.ValidationSummary("Account creation was unsuccessful. Please correct the errors and try again.", excludeFieldErrors: true, htmlAttributes: null)

    <fieldset>
        <legend>Registration Form</legend>
        <ol>
            <li class="name">
                <label for="name" @if(!ModelState.IsValidField("name")){<text>class="error-label"</text>}>Your (nick)name</label>
                <input type="text" id="name" name="name" value="@name" @Validation.For("name") />
                @* Write any name validation errors to the page *@
                @Html.ValidationMessage("name")
            </li>
            <li class="email">
                <label for="email" @if(!ModelState.IsValidField("email")){<text>class="error-label"</text>}>Email address</label>
                <input type="email" id="email" name="email" value="@email" @Validation.For("email") />
                @* Write any email validation errors to the page *@
                @Html.ValidationMessage("email")
            </li>
            <li class="password">
                <label for="password" @if(!ModelState.IsValidField("password")) {<text>class="error-label"</text>}>Password</label>
                <input type="password" id="password" name="password" @Validation.For("password") />
                @* Write any password validation errors to the page *@
                @Html.ValidationMessage("password")
            </li>
            <li class="confirm-password">
                <label for="confirmPassword" @if(!ModelState.IsValidField("confirmPassword")) {<text>class="error-label"</text>}>Confirm password</label>
                <input type="password" id="confirmPassword" name="confirmPassword" @Validation.For("confirmPassword") />
                @* Write any password validation errors to the page *@
                @Html.ValidationMessage("confirmPassword")
            </li>
            <li class="salt">
                <label for="salt" @if(!ModelState.IsValidField("salt")) {<text>class="error-label"</text>}>Enter something random</label>
                <input type="text" id="salt" name="salt" value="@salt" @Validation.For("salt") />
                @* Write any salt validation errors to the page *@
                @Html.ValidationMessage("salt")
            </li>
        </ol>
        <input type="submit" value="Register" />
    </fieldset>
</form>